var TermBlasterPopulator = {
  XUL_NS: "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul",
  loadPopup: function(key, popup) {
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefBranch);

    if (prefs.getPrefType("extensions.termblaster.opened." + key) != prefs.PREF_STRING) {
      throw "Corrupt Preferences: extensions.termblaster.opened." + key + " should be a string";
    }
    var uri = prefs.getCharPref("extensions.termblaster.opened." + key).replace(/^\s*|\s*$/g, "");

    if (uri == "") {
      popup.parentNode.hidden = true;
      return false;
    }

    var XMLDoc = document.implementation.createDocument("", "", null);
    XMLDoc.onload = function () {
      //var childNodeCount = popup.childNodes.length;
      //for (var i = 0; i < childNodeCount; i++) {
      //  popup.removeChild(popup.childNodes.item(0));
      //}
      while (popup.hasChildNodes()) {
        popup.removeChild(popup.firstChild);
      }

      try {
        TermBlasterPopulator.loadNode(XMLDoc.documentElement, popup);
      } catch (e) {
        alert("Could not load selected file.  Error: " + e.message);
        return;
      }

      if (!popup.hasChildNodes()) {
        popup.parentNode.hidden = true;
      }
    }
    XMLDoc.load(uri);
  },

  loadNode: function (iNode, popup) {
    if (iNode != null && iNode.localName != null) {
      if (iNode.localName == 'service') {
        this.appendMenuItem(iNode.attributes.getNamedItem("name").nodeValue, iNode.attributes.getNamedItem("query").nodeValue, popup);
      } else {
        if (iNode.localName == 'folder') {
          popup = this.appendMenu(iNode.attributes.getNamedItem("name").nodeValue, popup);
        }

        var cNode;
        for (var i = 0; i < iNode.childNodes.length; i++) {
          cNode = iNode.childNodes.item(i);
          if (cNode.localName != null) {
            this.loadNode(cNode, popup);
          }
        }

        if (!popup.parentNode.hidden && !popup.hasChildNodes()) {
          popup.parentNode.hidden = true;
        }
      }
    } 
  },

  appendMenu: function(aLabel, popup) {
    var menu = document.createElementNS(this.XUL_NS, "menu");
    menu.setAttribute("class", "menu-iconic termblaster-icon-folder");
    menu.setAttribute("label", aLabel);
    var menupopup = document.createElementNS(this.XUL_NS, "menupopup");
    menu.appendChild(menupopup);
    popup.appendChild(menu);

    return menupopup;
  },

  appendMenuItem: function(aLabel, aQuery, popup) {  
    var item = document.createElementNS(this.XUL_NS, "menuitem"); // create a new XUL menuitem
    item.setAttribute("class", "menuitem-iconic termblaster-icon-file");
    item.setAttribute("label", aLabel);
    item.setAttribute("oncommand", "termBlaster_SearchSelected('" + aQuery + "');");
    popup.appendChild(item);
  }
}

